Index: trunk/LMDZ.TITAN/libf/phytitan/calchim.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/calchim.F90	(revision 1950)
+++ trunk/LMDZ.TITAN/libf/phytitan/calchim.F90	(revision 1956)
@@ -1,4 +1,4 @@
 SUBROUTINE calchim(ngrid,qy_c,declin,dtchim,            &
-     ctemp,cpphi,cplay,cplev,czlay,czlev,dqyc)
+     ctemp,cpphi,cplay,cplev,czlay,czlev,dqyc,zdyevapCH4)
 
   !---------------------------------------------------------------------------------------------------------
@@ -56,4 +56,5 @@
   ! -----------------------------------------------------------------
 
+  USE, INTRINSIC :: iso_c_binding
   USE comchem_h
   USE dimphy
@@ -85,4 +86,5 @@
 
   REAL*8, DIMENSION(ngrid,klev,nkim), INTENT(OUT)  :: dqyc        ! Chemical species tendencies on GCM layers (mol/mol/s).
+  REAL*8, DIMENSION(ngrid),           INTENT(OUT)  :: zdyevapCH4  ! Diagnostic surface methane pseudo-evaporation flux (mol/mol/s).
 
   ! Local variables :
@@ -115,4 +117,6 @@
   REAL*8, DIMENSION(nlaykim_tot) :: rinter ! Inter-layer distance (km) to planetographic center (RA grid in chem. module).
   ! NB : rinter is on nlaykim_tot too, we don't care of the uppermost layer upper boundary altitude.
+
+  REAL(c_double) :: fluxCH4 ! Surface "evaporation" flux (mol/mol)
 
   ! Saved variables initialized at firstcall
@@ -465,8 +469,10 @@
              nomqy_c,cqy,                               &
              dtchim,latitude(ig)*180./pi,mass,md,       &
-             kedd,botCH4,krate,reactif,                 &
+             kedd,botCH4,fluxCH4,krate,reactif,         &
              nom_prod,nom_perte,prod,perte,             &
              aerprod,utilaer,cmaer,cprodaer,ccsn,ccsh,  &
              htoh2,surfhaze)
+
+        zdyevapCH4(ig) = fluxCH4 / dtchim ! Diagnostic pseudo-evaporation ( due to readjustement to botCH4 value ) (mol/mol/s)
 
         ! 5. Calculates tendencies on composition for advected tracers 
@@ -488,5 +494,6 @@
 
 
-     ELSE ! In 2D chemistry, if following grid point at same latitude, same zonal mean so don't do calculations again ! 
+     ELSE ! In 2D chemistry, if following grid point at same latitude, same zonal mean so don't do calculations again !
+        zdyevapCH4(ig)  = zdyevapCH4(igm1)
         dqyc(ig,:,:)    = dqyc(igm1,:,:) ! will be put back in 3D with longitudinal variations assuming same relative tendencies within a lat band
         ykim_up(:,ig,:) = ykim_up(:,igm1,:) ! no horizontal mixing in upper layers -> no longitudinal variations
Index: trunk/LMDZ.TITAN/libf/phytitan/physiq_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/physiq_mod.F90	(revision 1950)
+++ trunk/LMDZ.TITAN/libf/phytitan/physiq_mod.F90	(revision 1956)
@@ -387,7 +387,8 @@
       real temp_eq(nlayer), press_eq(nlayer) ! Planetary averages for the init. of saturation profiles (K,mbar)
 
-      ! Surface methane tank
-      real,dimension(:),allocatable,save :: tankCH4 ! Depth of surface methane tank (m)
-!$OMP THREADPRIVATE(tankCH4)
+      ! Surface methane
+      real, dimension(:), allocatable, save :: tankCH4    ! Depth of surface methane tank (m)
+      real, dimension(:), allocatable, save :: zdyevapCH4 ! Surface pseudo-evaporation flux (chemistry keeping constant surface humidity) (mol/mol/s).
+!$OMP THREADPRIVATE(tankCH4,zdyevapCH4)
 
       ! -----******----- FOR MUPHYS OPTICS -----******----- 
@@ -522,4 +523,5 @@
             allocate(dycchi(ngrid,nlayer,nkim)) ! only for chemical tracers
             allocate(qysat(nlayer,nkim))
+            allocate(zdyevapCH4(ngrid))
             
             ! Chemistry timestep
@@ -1199,11 +1201,14 @@
                  ! Here we send zonal average fields ( corrected with cond ) from dynamics to chem. module
                  call calchim(ngrid,ychimbar,declin,ctimestep,ztfibar,zphibar,  &
-                              zplaybar,zplevbar,zzlaybar,zzlevbar,dycchi)
+                              zplaybar,zplevbar,zzlaybar,zzlevbar,dycchi,zdyevapCH4)
                else ! 3D chemistry (or 1D run)
                  call calchim(ngrid,ychim,declin,ctimestep,pt,pphi,  &
-                              pplay,pplev,zzlay,zzlev,dycchi)
+                              pplay,pplev,zzlay,zzlev,dycchi,zdyevapCH4)
                endif ! if moyzon
 
             endif
+            
+            ! Add diagnostic-only surface pseudo-evapoaration in condensation tendency for bottom layer
+            zdqcond(:,1,chimi_indx(7)) = zdyevapCH4(:)*rat_mmol(chimi_indx(7))
             
             do iq=1,nkim
@@ -1559,4 +1564,5 @@
              call writediagfi(ngrid,cnames(iq),cnames(iq),'mol/mol',3,zq(:,:,iq+nmicro)/rat_mmol(iq+nmicro))
            enddo
+           call writediagfi(ngrid,"fluxCH4","Surface CH4 pseudo-evaporation",'mol/mol/s',2,zdyevapCH4)
          endif
 