Index: /trunk/LMDZ.GENERIC/README
===================================================================
--- /trunk/LMDZ.GENERIC/README	(revision 1979)
+++ /trunk/LMDZ.GENERIC/README	(revision 1980)
@@ -1370,2 +1370,4 @@
   and turb_mod
 
+== 31/07/2018 == EM
+Follow-up of change in maximum length of tracer names in the dynamics
Index: /trunk/LMDZ.GENERIC/libf/phystd/initracer.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/initracer.F	(revision 1979)
+++ /trunk/LMDZ.GENERIC/libf/phystd/initracer.F	(revision 1980)
@@ -1,5 +1,5 @@
       SUBROUTINE initracer(ngrid,nq,nametrac)
 
-      use surfdat_h
+      use surfdat_h, ONLY: dryness, watercaptag
       USE tracer_h
       USE callkeys_mod, only: water
@@ -22,14 +22,14 @@
 c=======================================================================
 
-      integer :: ngrid,nq
+      integer,intent(in) :: ngrid,nq
+      character(len=30),intent(in) :: nametrac(nq) ! name of the tracer from dynamics
 
 !      real qsurf(ngrid,nq)       ! tracer on surface (e.g.  kg.m-2)
 !      real co2ice(ngrid)           ! co2 ice mass on surface (e.g.  kg.m-2)
-      character(len=20) :: txt ! to store some text
+      character(len=30) :: txt ! to store some text
       integer iq,ig,count
       real r0_lift , reff_lift
 !      logical :: oldnames ! =.true. if old tracer naming convention (q01,...)
 
-      character*20 nametrac(nq)   ! name of the tracer from dynamics
 
 
@@ -67,12 +67,9 @@
        qext(:)=0.
 
-! Initialization: get tracer names from the dynamics and check if we are
-!                 using 'old' tracer convention ('q01',q02',...)
-!                 or new convention (full tracer names)
-      ! check if tracers have 'old' names
-
-! copy tracer names from dynamics
+
+! Initialization: copy tracer names from dynamics
         do iq=1,nq
           noms(iq)=nametrac(iq)
+          write(*,*)"initracer: iq=",iq,"noms(iq)=",trim(noms(iq))
         enddo
 
@@ -128,9 +125,4 @@
 
 
-      write(*,*) 'initracer: noms() ', noms
-
-
-      !print*,'Setting dustbin = 0 in initracer.F'
-      !dustbin=0
 
       ! 1. find dust tracers
Index: /trunk/LMDZ.GENERIC/libf/phystd/tracer_h.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/tracer_h.F90	(revision 1979)
+++ /trunk/LMDZ.GENERIC/libf/phystd/tracer_h.F90	(revision 1980)
@@ -4,23 +4,22 @@
        implicit none
 
-! nqtot : total number of tracers
-       INTEGER, SAVE :: nqtot
+       integer, save :: nqtot ! total number of tracers
 !$OMP THREADPRIVATE(nqtot)
 
-       character*20, DIMENSION(:), ALLOCATABLE :: noms   ! name of the tracer
-       real, DIMENSION(:), ALLOCATABLE :: mmol     ! mole mass of tracer (g/mol-1) 
-       real, DIMENSION(:), ALLOCATABLE :: radius   ! dust and ice particle radius (m)
-       real, DIMENSION(:), ALLOCATABLE :: rho_q    ! tracer densities (kg.m-3)
-       real, DIMENSION(:), ALLOCATABLE :: qext     ! Single Scat. Extinction coeff at 0.67 um
-       real, DIMENSION(:), ALLOCATABLE :: alpha_lift  ! saltation vertical flux/horiz flux ratio (m-1)
-       real, DIMENSION(:), ALLOCATABLE :: alpha_devil ! lifting coeeficient by dust devil
-       real, DIMENSION(:), ALLOCATABLE :: qextrhor ! Intermediate for computing opt. depth from q
+       character*30, save, allocatable :: noms(:)   ! name of the tracer
+       real, save, allocatable :: mmol(:)     ! mole mass of tracer (g/mol-1) 
+       real, save, allocatable :: radius(:)   ! dust and ice particle radius (m)
+       real, save, allocatable :: rho_q(:)    ! tracer densities (kg.m-3)
+       real, save, allocatable :: qext(:)     ! Single Scat. Extinction coeff at 0.67 um
+       real, save, allocatable :: alpha_lift(:)  ! saltation vertical flux/horiz flux ratio (m-1)
+       real, save, allocatable :: alpha_devil(:) ! lifting coeeficient by dust devil
+       real, save, allocatable :: qextrhor(:) ! Intermediate for computing opt. depth from q
 
-      real varian      ! Characteristic variance of log-normal distribution
-      real r3n_q     ! used to compute r0 from number and mass mixing ratio
-      real rho_dust     ! Mars dust density (kg.m-3)
-      real rho_ice     ! Water ice density (kg.m-3)
-      real rho_co2     ! CO2 ice density (kg.m-3)
-      real ref_r0        ! for computing reff=ref_r0*r0 (in log.n. distribution)
+       real,save :: varian      ! Characteristic variance of log-normal distribution
+       real,save :: r3n_q     ! used to compute r0 from number and mass mixing ratio
+       real,save :: rho_dust     ! Mars dust density (kg.m-3)
+       real,save :: rho_ice     ! Water ice density (kg.m-3)
+       real,save :: rho_co2     ! CO2 ice density (kg.m-3)
+       real,save :: ref_r0        ! for computing reff=ref_r0*r0 (in log.n. distribution)
 !$OMP THREADPRIVATE(noms,mmol,radius,rho_q,qext,alpha_lift,alpha_devil,qextrhor, &
 	!$OMP varian,r3n_q,rho_dust,rho_ice,rho_co2,ref_r0)
@@ -28,55 +27,55 @@
 ! tracer indexes: these are initialized in initracer and should be 0 if the
 !                 corresponding tracer does not exist
-      ! dust
-      integer, DIMENSION(:), ALLOCATABLE :: igcm_dustbin ! for dustbin 'dust' tracers
-      ! dust, special doubleq case
-      integer :: igcm_dust_mass   ! dust mass mixing ratio (for transported dust)
-      integer :: igcm_dust_number ! dust number mixing ratio (transported dust)
-      ! water
-      integer :: igcm_h2o_vap ! water vapour
-      integer :: igcm_h2o_ice ! water ice
-      ! chemistry:
-      integer :: igcm_co2
-      integer :: igcm_co
-      integer :: igcm_o
-      integer :: igcm_o1d
-      integer :: igcm_o2
-      integer :: igcm_o3
-      integer :: igcm_h
-      integer :: igcm_h2
-      integer :: igcm_oh
-      integer :: igcm_ho2
-      integer :: igcm_h2o2
-      integer :: igcm_n2
-      integer :: igcm_ar
-      integer,save :: igcm_n
-      integer,save :: igcm_no
-      integer,save :: igcm_no2
-      integer,save :: igcm_n2d
-      integer,save :: igcm_ch4
+       ! dust
+       integer,save,allocatable :: igcm_dustbin(:) ! for dustbin 'dust' tracers
+       ! dust, special doubleq case
+       integer,save :: igcm_dust_mass   ! dust mass mixing ratio (for transported dust)
+       integer,save :: igcm_dust_number ! dust number mixing ratio (transported dust)
+       ! water
+       integer,save :: igcm_h2o_vap ! water vapour
+       integer,save :: igcm_h2o_ice ! water ice
+       ! chemistry:
+       integer,save :: igcm_co2
+       integer,save :: igcm_co
+       integer,save :: igcm_o
+       integer,save :: igcm_o1d
+       integer,save :: igcm_o2
+       integer,save :: igcm_o3
+       integer,save :: igcm_h
+       integer,save :: igcm_h2
+       integer,save :: igcm_oh
+       integer,save :: igcm_ho2
+       integer,save :: igcm_h2o2
+       integer,save :: igcm_n2
+       integer,save :: igcm_ar
+       integer,save :: igcm_n
+       integer,save :: igcm_no
+       integer,save :: igcm_no2
+       integer,save :: igcm_n2d
+       integer,save :: igcm_ch4
 
-      integer :: igcm_ch3
-      integer :: igcm_ch
-      integer :: igcm_3ch2
-      integer :: igcm_1ch2
-      integer :: igcm_cho
-      integer :: igcm_ch2o
-      integer :: igcm_ch3o
-      integer :: igcm_c
-      integer :: igcm_c2
-      integer :: igcm_c2h
-      integer :: igcm_c2h2
-      integer :: igcm_c2h3
-      integer :: igcm_c2h4
-      integer :: igcm_c2h6
-      integer :: igcm_ch2co
-      integer :: igcm_ch3co
-      integer :: igcm_hcaer
+       integer,save :: igcm_ch3
+       integer,save :: igcm_ch
+       integer,save :: igcm_3ch2
+       integer,save :: igcm_1ch2
+       integer,save :: igcm_cho
+       integer,save :: igcm_ch2o
+       integer,save :: igcm_ch3o
+       integer,save :: igcm_c
+       integer,save :: igcm_c2
+       integer,save :: igcm_c2h
+       integer,save :: igcm_c2h2
+       integer,save :: igcm_c2h3
+       integer,save :: igcm_c2h4
+       integer,save :: igcm_c2h6
+       integer,save :: igcm_ch2co
+       integer,save :: igcm_ch3co
+       integer,save :: igcm_hcaer
 
 
 
-      ! other tracers
-      integer :: igcm_ar_n2 ! for simulations using co2 +neutral gaz
-      integer :: igcm_co2_ice ! CO2 ice 
+       ! other tracers
+       integer,save :: igcm_ar_n2 ! for simulations using co2 +neutral gaz
+       integer,save :: igcm_co2_ice ! CO2 ice 
 !$OMP THREADPRIVATE(igcm_dustbin,igcm_dust_mass,igcm_dust_number,igcm_h2o_vap,igcm_h2o_ice, &
 	!$OMP igcm_co2,igcm_co,igcm_o,igcm_o1d,igcm_o2,igcm_o3,igcm_h,igcm_h2,igcm_oh,	    &