Index: trunk/ICOSA_LMDZ/src/phystd/interface_icosa_lmdz.f90
===================================================================
--- trunk/ICOSA_LMDZ/src/phystd/interface_icosa_lmdz.f90	(revision 1929)
+++ trunk/ICOSA_LMDZ/src/phystd/interface_icosa_lmdz.f90	(revision 1982)
@@ -37,5 +37,5 @@
   INTEGER,SAVE :: nbp_phys_glo
   
-  CHARACTER(len=20),SAVE,ALLOCATABLE :: tname(:) ! tracer names
+  CHARACTER(len=30),SAVE,ALLOCATABLE :: tname(:) ! tracer names
   REAL,SAVE :: pday ! number of ellapsed sols since Ls=0
   REAL,SAVE :: ptime ! "universal time" as fraction of sol (e.g. 0.5 for noon)
@@ -59,12 +59,6 @@
   USE mod_grid_phy_lmdz, ONLY : unstructured
   USE mod_phys_lmdz_omp_data, ONLY: klon_omp
-!  USE time_phylmdz_mod, ONLY: init_time_lmdz => init_time
   USE transfert_mod
   USE physics_distribution_mod, ONLY : init_physics_distribution
-!  USE geometry_mod, ONLY : init_geometry
-!  USE vertical_layers_mod, ONLY : init_vertical_layers
-!  USE infotrac_phy, ONLY : init_infotrac_phy
-!  USE inifis_mod, ONLY : inifis 
-!  USE phyaqua_mod, ONLY : iniaqua 
    
   
@@ -81,22 +75,4 @@
   REAL(rstd) :: pseudoalt(llm)
 
-  INTEGER :: run_length  
-  INTEGER :: annee_ref  
-  INTEGER :: day_ref    
-  INTEGER :: day_ini    
-  REAL    :: start_time 
-  REAL    :: physics_timestep    
-
-
-  INTEGER                       :: nqo, nbtr
-  CHARACTER(len=4)              :: type_trac
-  CHARACTER(len=20),ALLOCATABLE :: tname(:)    ! tracer short name for restart and diagnostics
-  CHARACTER(len=23),ALLOCATABLE :: ttext(:)     ! tracer long name for diagnostics
-  INTEGER,ALLOCATABLE           :: niadv(:)    ! equivalent dyn / physique
-  INTEGER,ALLOCATABLE           :: conv_flg(:) ! conv_flg(it)=0 : convection desactivated for tracer number it 
-  INTEGER,ALLOCATABLE           :: pbl_flg(:)  ! pbl_flg(it)=0  : boundary layer diffusion desactivaded for tracer number it 
-  CHARACTER(len=8),ALLOCATABLE :: solsym(:)  ! tracer name from inca
-
-  INTEGER :: iflag_phys    
   INTEGER :: nbp_phys, nbp_phys_glo
   
Index: trunk/ICOSA_LMDZ/src/phyvenus/interface_icosa_lmdz.f90
===================================================================
--- trunk/ICOSA_LMDZ/src/phyvenus/interface_icosa_lmdz.f90	(revision 1929)
+++ trunk/ICOSA_LMDZ/src/phyvenus/interface_icosa_lmdz.f90	(revision 1982)
@@ -37,5 +37,5 @@
   INTEGER,SAVE :: nbp_phys_glo
   
-  CHARACTER(len=20),SAVE,ALLOCATABLE :: tname(:) ! tracer names
+  CHARACTER(len=30),SAVE,ALLOCATABLE :: tname(:) ! tracer names
   REAL,SAVE :: pday ! number of ellapsed sols since Ls=0
   REAL,SAVE :: ptime ! "universal time" as fraction of sol (e.g. 0.5 for noon)
@@ -75,22 +75,4 @@
   REAL(rstd) :: pseudoalt(llm)
 
-!  INTEGER :: run_length  
-!  INTEGER :: annee_ref  
-!  INTEGER :: day_ref    
-!  INTEGER :: day_ini    
-!  REAL    :: start_time 
-!  REAL    :: physics_timestep    
-
-
-!  INTEGER                       :: nqo, nbtr
-!  CHARACTER(len=4)              :: type_trac
-!  CHARACTER(len=20),ALLOCATABLE :: tname(:)    ! tracer short name for restart and diagnostics
-!  CHARACTER(len=23),ALLOCATABLE :: ttext(:)     ! tracer long name for diagnostics
-!  INTEGER,ALLOCATABLE           :: niadv(:)    ! equivalent dyn / physique
-!  INTEGER,ALLOCATABLE           :: conv_flg(:) ! conv_flg(it)=0 : convection desactivated for tracer number it 
-!  INTEGER,ALLOCATABLE           :: pbl_flg(:)  ! pbl_flg(it)=0  : boundary layer diffusion desactivaded for tracer number it 
-!  CHARACTER(len=8),ALLOCATABLE :: solsym(:)  ! tracer name from inca
-
-!  INTEGER :: iflag_phys    
   INTEGER :: nbp_phys, nbp_phys_glo
   
@@ -230,6 +212,6 @@
   INTEGER :: iflag_trac
   CHARACTER(len=4)              :: type_trac
-  CHARACTER(len=20),ALLOCATABLE :: tname(:)    ! tracer short name for restart and diagnostics
-  CHARACTER(len=23),ALLOCATABLE :: ttext(:)     ! tracer long name for diagnostics
+!  CHARACTER(len=30),ALLOCATABLE :: tname(:)    ! tracer short name for restart and diagnostics
+  CHARACTER(len=33),ALLOCATABLE :: ttext(:)     ! tracer long name for diagnostics
   TYPE(t_field),POINTER,SAVE    :: f_ind_cell_glo(:)
   